<?php
	// 20131001-Juri NAGATSU
	//**********************************************************************************
    // テンプレートファイル名
    $kml_template = "kml_template.txt"; 	// 日本語版
    //$kml_template = "kml_template_en.txt"; 	// 英語版(コメントアウトで無効)
    
	// 出力ファイル名
	$file_name = "volcano.kml"; 	// 日本語版
	//$file_name = "volcano_en.kml"; 	// 英語版(コメントアウトで無効)
    
	// csvファイル
	$csv_file ="csv_file.csv";	// ファイルを変更する場合は，ここを修正してください
	//**********************************************************************************
    
    $fp_temp = fopen( $kml_template, 'r' );

	/*csvファイルの文字コードがSJISの場合，下記5行のコメントアウトしてください*/
	$text = file_get_contents( $csv_file );
	$text = mb_convert_encoding($text,"UTF-8","SJIS");
	$fp_csv = fopen( "php://temp","r+" );
	fwrite( $fp_csv,$text );
	rewind( $fp_csv );

	/*csvファイルの文字コードがUTF-8の場合，下記1行のコメントアウトしてください*/
//	$fp_csv = fopen( $csv_file, 'r' );

	$fp_kml = fopen( $file_name, "w" ); 

    // ファイルの読み込み 
    if (!file_exists($kml_template)) exit; 
    $lines = file($kml_template);
    $header1 = $lines[0];
    $header2 = $lines[1];
    $footer = $lines[3];
    
	@fwrite( $fp_kml , $header1);// ファイル出力_XML宣言
	@fwrite( $fp_kml , $header2);// ファイル出力

    while ($csv_data = fgetcsv($fp_csv,1024)){
    	// 変数の定義 
	    $name = $csv_data[0];//火山名
	    $name_j = $csv_data[1];//読み
	    $name_e = $csv_data[2];//アルファベット
	    $longitude1 = $csv_data[4];//経度
	    $latitudes1 = $csv_data[3];//緯度
	    $img = $csv_data[5];//サムネールリンク
	    $html_link = $csv_data[6];//個別火山リンク(日英共通)
	    	    
	    // 経度緯度の四捨五入
	    $longitude = strval(round($longitude1,5));//経度
	    $latitudes = strval(round($latitudes1,5));//緯度
	    // 変数を埋め込む部分を再定義
        $body = $lines[2];
	    // 変数の埋め込み 
	    while (preg_match("/\{%(.*)\}/U", $body, $match)){
	        	$body = str_replace($match[0],$$match[1],$body);
	    } 
		@fwrite( $fp_kml , $body);// ファイル出力
	}
	@fwrite( $fp_kml , $footer);// ファイル出力

	fclose($fp_temp);	
	fclose($fp_csv);	
	fclose($fp_kml);
?> 